/* AppController.h
 * Taskmaster
 * Copyright (C) 2003 Arthur Lewis
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#import <AppKit/AppKit.h>
#import "Task.h"
#import "Day.h"
#import "TaskDB.h"


@interface AppController:NSObject {
    
    TaskDB* DB;
    NSMutableDictionary * days;
    Day *currentDay;
    NSCalendarDate * currentDate;
    NSCalendarDate * openingDate;
    NSMutableArray * tasksForToday;
    NSMutableArray * allTasks;
    NSMutableArray * tasks;
    NSFileManager *manager;
    
    IBOutlet NSTableView * dbTable;
    IBOutlet NSTableView * dayTable;
    IBOutlet NSTextField * textField;

    NSCalendarDate * today;
    NSString * path;
    NSString * dirPath;

    BOOL OKToSave;

    
}
- (id)initFromScratch;
- (NSString *)objectNameFromDate;
- (IBAction)addButtonPressed:(NSEvent *)event;
- (IBAction)addSelectedTask:(NSEvent *)event;
- (IBAction)removeSelectedTask:(NSEvent *)event;
- (IBAction)dayUp:(id)sender;
-(void)dayChange:(int)numDays;

- (BOOL)save; //Returns whether save was successful.
- (void)awakeFromNib;

@end
