/* Task.h
 * Taskmaster
 * Copyright (C) 2003 Arthur Lewis
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#import <Foundation/Foundation.h>


@interface Task : NSObject <NSCoding> {
    NSString *name;
    NSNumber *repeatStatus;
    NSNumber *percentOfMonth;

    int days;
    NSCalendarDate *dateLastPerformed;
    NSCalendarDate *oldDateLastPerformed;
    NSCalendarDate *dateLastPosted; // how long has thing sat on my To Do List?
    NSCalendarDate *oldDateLastPosted;
    NSNumber *toDo;
}

- (id)initWithName:(NSString *)newName repeatStatus:(NSNumber *)status
    dateLastPosted:(NSCalendarDate *)newPostDate
 dateLastPerformed:(NSCalendarDate *)newPerformDate;
- (void)dealloc;
- (void)setName:(NSString *)newName;
- (void)setRepeatStatus:(NSNumber *)newStatus;
- (void)setPercentOfMonth:(NSNumber *)newPercent;
- (void)setDateLastPerformed:(NSCalendarDate *)newDate;
- (void)setDateLastPosted:(NSCalendarDate *)newDate;

- (NSString *)getName;
- (NSNumber *)getRepeatStatus;
- (NSNumber *)getDaysSinceLast;
- (NSNumber *)getPercentOfMonth;
- (NSNumber *)getToDo;
- (NSCalendarDate *)getDateLastPerformed;
- (NSCalendarDate *)getDateLastPosted;
- (void)undoDateLastPerformed;
- (void)undoDateLastPosted;


@end
