/* Task.m
 * Taskmaster
 * Copyright (C) 2003 Arthur Lewis
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#import "Task.h"

@implementation Task

- (id)init {
    return [self initWithName:@"Untitled Task" repeatStatus:NO dateLastPosted:nil
            dateLastPerformed:nil];
    
}

- (id)initWithName:(NSString *)newName repeatStatus:(NSNumber *)status
          dateLastPosted:(NSCalendarDate *)newPostDate
 dateLastPerformed:(NSCalendarDate *)newPerformDate {

    if (self = [super init]) {
        [self setName:newName];
        [self setRepeatStatus:status];
        if (newPostDate == nil) {
            dateLastPosted = [NSCalendarDate calendarDate];
        }
        else dateLastPosted = newPostDate;

        if (newPerformDate == nil) {
            dateLastPerformed = [NSCalendarDate calendarDate];
        }
        else dateLastPerformed = newPerformDate;

        [dateLastPosted retain];
        [dateLastPerformed retain];
        toDo = [NSNumber numberWithBool:YES];
    }        
    return self;
}

- (id)initWithCoder:(NSCoder *)coder {
    return [self initWithName:[coder decodeObjectForKey:@"Name"]
                 repeatStatus:[coder decodeObjectForKey:@"RepeatStatus"]
               dateLastPosted:[coder decodeObjectForKey:@"DateLastPosted"]
            dateLastPerformed:[coder decodeObjectForKey:@"DateLastPerformed"]];
}

-(void)encodeWithCoder:(NSCoder *)coder {
    [coder encodeObject:name forKey:@"Name"];
    [coder encodeObject:repeatStatus forKey:@"RepeatStatus"];
    [coder encodeObject:dateLastPosted forKey:@"DateLastPosted"];
    [coder encodeObject:dateLastPerformed forKey:@"DateLastPerformed"];
    
}

//comparing by desc
- (BOOL)isEqual:(NSTask *)otherTask {
    return (self == otherTask);
}
- (NSString *)description {
    return [self getName];
}

- (void)setName:(NSString *)newName {
    [newName retain];
    [name release];
    name = newName;
}
- (void)setRepeatStatus:(NSNumber *)newStatus {
    repeatStatus = newStatus;
}

// This si totally confused and probably useless
- (NSNumber *)getDaysSinceLast {
    NSCalendarDate * lastDate;
/*    if (repeatStatus) {
       lastDate = dateLastPerformed;
    }
    else lastDate = dateLastPosted; */
    lastDate = dateLastPerformed;
    NSLog([self getName]);
    NSLog([lastDate descriptionWithCalendarFormat:@"%d.%m.%Y"]);
    if (lastDate != nil) {
        [[NSCalendarDate calendarDate] years:NULL months:NULL days:&days hours:NULL
                                 minutes:NULL seconds:NULL sinceDate:lastDate];
    }
    else days = 0;
    printf("%i\n", days);
    NSNumber *daysObject;
    daysObject = [NSNumber numberWithInt:days];
    [daysObject retain];
    return daysObject;
}



- (NSNumber *)getPercentOfMonth {
    return percentOfMonth;
}

- (NSString *)getName{
    return name;
}

- (NSNumber *)getRepeatStatus{
    return repeatStatus;
}
- (NSCalendarDate *)getDateLastPerformed {
    return dateLastPerformed;
}

- (NSCalendarDate *)getDateLastPosted {
    return dateLastPosted;
}

- (NSNumber *)getToDo {
    return toDo;
}

- (void)setDateLastPerformed:(NSCalendarDate *)newDate {
    [newDate retain];
    [oldDateLastPerformed release];
    oldDateLastPerformed = dateLastPerformed;
    [oldDateLastPerformed retain];
    dateLastPerformed = newDate;
}

//could these possibly be the same object?
- (void)undoDateLastPosted {
    [dateLastPosted release];
    dateLastPosted = oldDateLastPosted;
}

-(void)undoDateLastPerformed {
    [dateLastPerformed release];
    dateLastPerformed = oldDateLastPerformed;
}
- (void)setDateLastPosted:(NSCalendarDate *)newDate {
    [newDate retain];
    [oldDateLastPosted release];
    oldDateLastPosted = dateLastPosted;
    [oldDateLastPerformed retain];

    dateLastPosted = newDate;
    
}

- (void)dealloc {
    [name release];
    [super dealloc];
}

@end
